/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.spec;

import java.util.Collections;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBuffer;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuStruct;

/**
 * The {@code L1} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */

public final class L1 extends MmuBuffer {
  private static L1 INSTANCE = null;

  public static L1 get() {
    if (null == INSTANCE) {
      INSTANCE = new L1();
    }
    return INSTANCE;
  }

  private final PA pa = PA.get();

  public static final class Entry extends MmuStruct {
    public final IntegerVariable V;
    public final IntegerVariable TAG;
    public final IntegerVariable DATA;

    public Entry(final String name) {
      super(name);

      this.V = new IntegerVariable(name + ".V", 1);
      this.TAG = new IntegerVariable(name + ".TAG", 20);
      this.DATA = new IntegerVariable(name + ".DATA", 256);

      addField(V);
      addField(TAG);
      addField(DATA);
    }
  }

  public final IntegerVariable V;
  public final IntegerVariable TAG;
  public final IntegerVariable DATA;

  private L1() {
    this("L1");
  }

  private L1(final String name) {
    super(
        name,
        Kind.UNMAPPED,
        4L,
        128L,
        PA.get(),
        MmuExpression.var(PA.get().value, 12, 31),
        MmuExpression.var(PA.get().value, 5, 11),
        MmuExpression.var(PA.get().value, 0, 4),
        Collections.<MmuBinding>emptyList(), // set up with setMatchBindings
        true,
        null
    );

    this.V = new IntegerVariable(name + ".V", 1);
    this.TAG = new IntegerVariable(name + ".TAG", 20);
    this.DATA = new IntegerVariable(name + ".DATA", 256);

    addField(V);
    addField(TAG);
    addField(DATA);

    setMatchBindings(Arrays.<MmuBinding>asList(
        new MmuBinding(V, new BigInteger("1", 10)),
        new MmuBinding(TAG, PA.get().value.field(12, 31))));
  }
}
