/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.spec;

import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;

/**
 * The {@code Specification} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */

public final class Specification implements MmuSubsystem.Holder {
  private final MmuSubsystem spec;

  public Specification() {
    final MmuSubsystem.Builder builder = new MmuSubsystem.Builder();

    builder.registerAddress(VA.get());
    builder.registerAddress(PA.get());

    builder.registerBuffer(L1.get());
    builder.registerBuffer(L2.get());
    builder.registerBuffer(M.get());

    builder.registerSegment(SEG.get());

    final pmem pmem = new pmem(builder);

    builder.setVirtualAddress(VA.get());
    builder.setPhysicalAddress(PA.get());
    builder.setStartAction(pmem.START);
    builder.setTargetBuffer(M.get());

    this.spec = builder.build();
  }

  @Override
  public MmuSubsystem getSpecification() {
    return spec;
  }

  public static void main(final String[] args) {
    System.out.println(new Specification().getSpecification());
  }
}
